<?php
namespace moonlight\eticket;
class eticket_ajax_validation {
	private $co_db;
	public function __construct( $p_co_db ){
		$this->co_db = $p_co_db;
	}
	public function __destruct(){
		unset($this->co_db);
	}
	/**
	 * Check user name duplication on usr_short_name
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_user_name_duplication($p_username) {
		return $this->co_db->ajax_validation_check_user_name_duplication($p_username);
	}
	/**
	 * Check user name duplication on usr_id
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_user_name_duplication_edit($p_username,$p_user_id) {
		return $this->co_db->ajax_validation_check_user_name_duplication_edit($p_username,$p_user_id);
	}
	/**
	 * Check user duplication on usr_new_ic_no
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_user_ic_no_duplication($p_user_ic_no) {
		return $this->co_db->ajax_validation_check_user_ic_no_duplication($p_user_ic_no);
	}
	/**
	 * Check user duplication on usr__ic_no except current user for edit
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_user_ic_no_duplication_edit($p_user_role,$p_user_id) {
		return $this->co_db->ajax_validation_check_user_ic_no_duplication_edit($p_user_role,$p_user_id);
	}
	/**
	 * Check duplication on user_role
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_user_role_duplication($p_user_role) {
		return $this->co_db->ajax_validation_check_user_role_duplication($p_user_role);
	}
	/**
	 * Check duplication on user_role except current role on edit
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_user_role_duplication_edit($p_user_role, $p_primary_table_id,$p_agency_id) {
		return $this->co_db->ajax_validation_check_user_role_duplication_edit($p_user_role,$p_primary_table_id,$p_agency_id);
	}
	/**
	 * Check duplication on locations except current locations on edit
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_location_duplication($p_user_role) {
		return $this->co_db->ajax_validation_check_location_duplication($p_user_role);
	}
	/**
	 * Check duplication on agency code
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_agency_duplication($p_user_role) {
		return $this->co_db->ajax_validation_check_agency_duplication($p_user_role);
	}
	/**
	 * Check duplication on locations except current locations on edit
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_location_duplication_edit($p_user_role,$p_primary_table_id) {
		return $this->co_db->ajax_validation_check_location_duplication_edit($p_user_role,$p_primary_table_id);
	}
	/**
	 * Check duplication on agency except current agency on edit
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_agency_duplication_edit($p_user_role,$p_primary_table_id) {
		return $this->co_db->ajax_validation_check_agency_duplication_edit($p_user_role,$p_primary_table_id);
	}
	/**
	 * Check duplication on location name
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_location_name_duplication($p_user_role) {
		return $this->co_db->ajax_validation_check_location_name_duplication($p_user_role);
	}
	/**
	 * Check duplication on agency name
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_agency_name_duplication($p_user_role) {
		return $this->co_db->ajax_validation_check_agency_name_duplication($p_user_role);
	}
	/**
	 * Check duplication on agency name except current agency name on edit
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_agency_name_duplication_edit($p_user_role,$p_primary_table_id) {
		return $this->co_db->ajax_validation_check_agency_name_duplication_edit($p_user_role,$p_primary_table_id);
	}
	/**
	 * Check duplication on location name except current location name on edit
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_location_name_duplication_edit($p_user_role,$p_primary_table_id) {
		return $this->co_db->ajax_validation_check_location_name_duplication_edit($p_user_role,$p_primary_table_id);
	}
	/**
	 * Check duplication on ticket_category code
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_ticket_category_duplication($p_user_role,$p_v_ticket_category_type_text=NULL) {
		return $this->co_db->ajax_validation_check_ticket_category_duplication($p_user_role,$p_v_ticket_category_type_text);
	}
	/**
	 * Check duplication on ticket_category code except current category for edit
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_ticket_category_duplication_edit($p_user_role,$p_primary_table_id,$p_v_ticket_category_type_text=NULL) {
		return $this->co_db->ajax_validation_check_ticket_category_duplication_edit($p_user_role,$p_primary_table_id,$p_v_ticket_category_type_text);
	}
	/**
	 * Check duplication on ticket_category name except current category for edit
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_ticket_category_name_duplication($p_user_role,$p_v_ticket_category_type_text=NULL) {
		return $this->co_db->ajax_validation_check_ticket_category_name_duplication($p_user_role,$p_v_ticket_category_type_text);
	}
	/**
	 * Check duplication on ticket_category name except current category for edit
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_ticket_category_name_duplication_edit($p_user_role,$p_primary_table_id,$p_v_ticket_category_type_text=NULL) {
		return $this->co_db->ajax_validation_check_ticket_category_name_duplication_edit($p_user_role,$p_primary_table_id,$p_v_ticket_category_type_text);
	}
	/**
	 * Check duplication on ticket_profile code
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_ticket_profile_duplication($p_user_role) {
		return $this->co_db->ajax_validation_check_ticket_profile_duplication($p_user_role);
	}
	/**
	 * Check duplication on  ticket_profile code for edit except current
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_ticket_profile_duplication_edit($p_user_role,$p_primary_table_id) {
		return $this->co_db->ajax_validation_check_ticket_profile_duplication_edit($p_user_role,$p_primary_table_id);
	}
	/**
	 * Check duplication on  ticket_profile name
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_ticket_profile_name_duplication($p_user_role) {
		return $this->co_db->ajax_validation_check_ticket_profile_name_duplication($p_user_role);
	}
	/**
	 * Check duplication on  ticket_profile name for edit except current
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_ticket_profile_name_duplication_edit($p_user_role,$p_primary_table_id) {
		return $this->co_db->ajax_validation_check_ticket_profile_name_duplication_edit($p_user_role,$p_primary_table_id);
	}
	/**
	 * Retrieve location address,logo on id
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_get_locations_data($p_location_id) {
		return $this->co_db->ajax_validation_get_locations_data($p_location_id);
	}
	/**
	 * Retrieve agency logo on ag_id
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_get_agency_data($p_agency_user_id) {
		return $this->co_db->ajax_validation_get_agency_data($p_agency_user_id);
	}
	/**
	 * Retrieve locations on agency_id
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_get_agency_locations($p_agency_id, $p_restriction=NULL) {
		return $this->co_db->ajax_validation_get_agency_locations($p_agency_id,$p_restriction);
	}
	/**
	 * Check Ticket name duplication on template_name in ticket_template
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_ticket_name_duplication($p_ticket_name) {
		return $this->co_db->ajax_validation_check_ticket_name_duplication($p_ticket_name);
	}
	/**
	 * Check Ticket name duplication on template_name in ticket_template while editing
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_ticket_name_duplication_edit($p_ticket_name,$p_ticket_id) {
		return $this->co_db->ajax_validation_check_ticket_name_duplication_edit($p_ticket_name,$p_ticket_id);
	}
	/**
	 * Check User Permissions by Permission Name
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_permission($p_permissions_name, $p_module_name=NULL) {
		return $v_permissions = $this->co_db->ajax_validation_check_permission($p_permissions_name, $p_module_name);
	}
	/**
	 * Get Code table Values By Key
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_code_table_data($p_key_value) {
		return $this->co_db->ajax_validation_code_table_data($p_key_value);
	}
	/**
	 * GET CATEGORIES AGAINST LOCATION ID
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_get_categories_against_locations($p_location_id) {
		return $this->co_db->ajax_validation_get_categories_against_locations($p_location_id);
	}
	/**
	 * GET TICKET TYPES AGAINST LOCATIONS
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_get_category_types($p_location_id, $p_category_type_id) {
		return $this->co_db->ajax_validation_get_category_types($p_location_id, $p_category_type_id);
	}
	/**
	 * GET TICKET PROFILE DATA AGAINST CATEGORY
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_get_ticket_profile_against_category($p_category_id) {
		return $this->co_db->ajax_validation_get_ticket_profile_against_category($p_category_id);
	}
	/**
	 * GET TICKET TEMPLATE EXISTS AGAINST PROFILE
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_get_ticket_template_against_category($p_profile_id) {
		return $this->co_db->ajax_validation_get_ticket_template_against_category($p_profile_id);
	}
	/**
	 * Check Ticket Transaction Sequence
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_get_ticket_sequence_transaction($p_select_location=NULL) {
		return $this->co_db->ajax_validation_get_ticket_sequence_transaction($p_select_location);
	}
	/**
	 * Check Ticket Sequence
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_get_ticket_sequence($p_qty) {
		return $this->co_db->ajax_validation_get_ticket_sequence($p_qty);
	}
	/**
	 * Get Location Per day
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_get_location_per_day($p_select_location=NULL) {
		return $this->co_db->ajax_validation_get_location_per_day($p_select_location);
	}
	/**
	 * Get Location Per day USED
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_get_location_per_day_used($p_select_location=NULL) {
		return $this->co_db->ajax_validation_get_location_per_day_used($p_select_location);
	}
	/**
	 * DELETE AGENCY UPLOADED LOGO
	 *
	 * @access public
	 * @return
	 */
	public function ajax_validation_check_agency_delete_uploaded_logo($p_master_id) {
		return $this->co_db->ajax_validation_check_agency_delete_uploaded_logo($p_master_id);
	}
}
?>