<?php
namespace moonlight\eticket;
class eticket_location_mysql {
	private $co_db_root;
	public function __call($name, $arguments){
		$v_tmp_arr = explode("_", $name);
		$v_call_obj = $v_tmp_arr[0];
		if(isset($this->co_db_root)){
			return call_user_func_array(array($this->co_db_root, $name), $arguments);
		}
	}
	public function __construct( &$p_co_db ){
		$this->co_db_root = $p_co_db;
	}
	/**
	 * Insert new location
	 *
	 * @access public
	 * @return
	 */
	public function location_save($p_data) {
		if( isset($p_data) ) {
			if( count($p_data) > 0 ) {
				$v_query = "INSERT INTO
						" . $this->get_db_table_prefix() . "locations
					SET
						name = '".\U::safe_sql_string($p_data['name'])."',
						code = '".\U::safe_sql_string($p_data['code'])."',
						agency_id = '".\U::safe_sql_string($p_data['agency_id'])."',
						contact_no = '".\U::safe_sql_string($p_data['contact_no'])."',
						fax = '".\U::safe_sql_string($p_data['fax'])."',
						email = '".\U::safe_sql_string($p_data['email'])."',
						address = '".\U::safe_sql_string($p_data['address'])."',
						post_code = '".\U::safe_sql_string($p_data['post_code'])."',
						division = '".\U::safe_sql_string($p_data['division'])."',
						person_charge = '".\U::safe_sql_string($p_data['person_charge'])."',
						total_ticket_per_day = '".\U::safe_sql_string($p_data['total_ticket_per_day'])."',
						sarawak_pay_merchant = '".\U::safe_sql_string($p_data['sarawak_pay_merchant'])."',
						sarawak_pay_sifbas = '".\U::safe_sql_string($p_data['sarawak_pay_sifbas'])."',
						merchant_id = '".\U::safe_sql_string($p_data['merchant_id'])."',
						merchant_private_key = '".\U::safe_sql_string($p_data['merchant_private_key'])."',
						ptj_code = '".\U::safe_sql_string($p_data['ptj_code'])."',
						remarks = '".\U::safe_sql_string($p_data['remarks'])."',
						_rec_status = '".\U::safe_sql_string($p_data['_rec_status'])."',
						_rec_created_by = '".\U::safe_sql_string($p_data['_rec_created_by'])."',
						_rec_created_on = '".\U::safe_sql_string($p_data['_rec_created_on'])."',
						_rec_modified_by = '".\U::safe_sql_string($p_data['_rec_modified_by'])."',
						_rec_modified_on = '".\U::safe_sql_string($p_data['_rec_modified_on'])."'
					";
				$v_role_add = $this->co_db_root->execute_query($v_query);
				if ($v_role_add) {
					return $v_role_id = $this->co_db_root->get_last_insert_id();
				}
			}
		}
	}
	/**
	 * Update location
	 *
	 * @access public
	 * @return
	 */
	public function location_update($p_data, $p_id_to_update_table) {
		if( isset($p_data) ) {
			if( count($p_data) > 0 ) {
				if( isset($p_id_to_update_table) && $p_id_to_update_table != '' ) {
					$v_query = "UPDATE
							" . $this->get_db_table_prefix() . "locations
						SET
							name = '".\U::safe_sql_string($p_data['name'])."',
							code = '".\U::safe_sql_string($p_data['code'])."',
							agency_id = '".\U::safe_sql_string($p_data['agency_id'])."',
							contact_no = '".\U::safe_sql_string($p_data['contact_no'])."',
							email = '".\U::safe_sql_string($p_data['email'])."',
							fax = '".\U::safe_sql_string($p_data['fax'])."',
							address = '".\U::safe_sql_string($p_data['address'])."',
							post_code = '".\U::safe_sql_string($p_data['post_code'])."',
							division = '".\U::safe_sql_string($p_data['division'])."',
							person_charge = '".\U::safe_sql_string($p_data['person_charge'])."',
							location_administrators = '".\U::safe_sql_string($p_data['location_admins'])."',
							total_ticket_per_day = '".\U::safe_sql_string($p_data['total_ticket_per_day'])."',
							sarawak_pay_merchant = '".\U::safe_sql_string($p_data['sarawak_pay_merchant'])."',
							sarawak_pay_sifbas = '".\U::safe_sql_string($p_data['sarawak_pay_sifbas'])."',
							merchant_id = '".\U::safe_sql_string($p_data['merchant_id'])."',
							merchant_private_key = '".\U::safe_sql_string($p_data['merchant_private_key'])."',
							ptj_code = '".\U::safe_sql_string($p_data['ptj_code'])."',
							remarks = '".\U::safe_sql_string($p_data['remarks'])."',
							_rec_modified_by = '".\U::safe_sql_string($p_data['_rec_modified_by'])."',
							_rec_modified_on = '".\U::safe_sql_string($p_data['_rec_modified_on'])."'
						WHERE
							id = '".\U::safe_sql_string($p_id_to_update_table)."'
						";
					$v_role_add = $this->co_db_root->execute_query($v_query);
					if ($v_role_add) {
						return TRUE;
					}
				}
			}
		}
	}
	/**
	 * Get location by id
	 *
	 * @access public
	 * @return
	 */
	public function location_get_by_id($p_location_id) {
		if( isset($p_location_id) ) {
			$v_query = "SELECT
							*
				 		FROM 
				 			" . $this->get_db_table_prefix() . "locations 
				 		WHERE
				 			id = '".\U::safe_sql_string($p_location_id)."'
				 ";
			$v_locations_data = $this->co_db_root->execute_query($v_query);	
			if( isset($v_locations_data) ) {
				if( $v_locations_data != '' ) {
					return $v_locations_data[0];
				}
			}
		}
	}
	/**
	 * Get vode table values on key
	 *
	 * @access public
	 * @return
	 */
	public function location_get_code_table_data_on_key_name($p_key) {
			$v_query = "SELECT
							*
				 		FROM 
				 			" . $this->get_db_table_prefix() . "code_table 
				 		WHERE
				 			key_name = '".\U::safe_sql_string($p_key)."'
				 ";
			$v_data = $this->co_db_root->execute_query($v_query);
			if( isset($v_data) ) {
				if( $v_data != '' ) {
					return $v_data[0];
				}
			}
	}
	/**
	 * Soft del location
	 *
	 * @access public
	 * @return
	 */
	public function location_delete( $p_value ){
		$v_query = 	"UPDATE 
						" . $this->get_db_table_prefix() . "locations 
					SET
						_rec_deleted_on = \"" . \U::safe_sql_string( date("Y-m-d H:i:s") ) . "\",
						_rec_deleted_by = \"" . \U::safe_sql_string( \E::get_session('usr_id') ) . "\",
						_rec_status = \"DELETED\"
					WHERE 
						id = \"" . \U::safe_sql_string( $p_value['id'] ) . "\"
					";
		$v_result = $this->co_db_root->execute_query($v_query);
		if( $v_result ){
			return TRUE;
		} else {
			return FALSE;
		}
	}
	/**
	 * Retrieve location listing with
	 *
	 * @access public
	 * @return
	 */
	public function location_list_with_no_post($p_cond=NULL, $p_sort_by=NULL, $p_order_by=NULL, $p_page_start=NULL, $p_page_length=NULL){
		$v_col_name = "id";
		$v_location_condition = \E::get('obj_curr_module')->get_location_condition($v_col_name);
		$v_col_name = "agency_id";
		$v_agency_condition = \E::get('obj_curr_module')->get_agency_condition($v_col_name);
		$v_location_name_code = $p_cond['location_name_code']; 
		$v_location_name_code_search = "";
		if( $v_location_name_code != '' ) {
			$v_location_name_code_search = " AND ( name LIKE  '%" . \U::safe_sql_string($v_location_name_code) . "%'  OR code LIKE '%" . \U::safe_sql_string($v_location_name_code) . "%'  )	 ";
		}
		$v_agency_filter = $p_cond['location_filter'];
		$v_agency_filter_search = "";
		if( $v_agency_filter != '' ) {
			$v_agency_filter_implode = "'" . implode ( "', '", \U::safe_sql_string($v_agency_filter)) . "'";
			$v_agency_filter_search = " AND ( id IN(".$v_agency_filter_implode.") ) ";
		}
		$v_division_filter = $p_cond['division_filter'];
		$v_division_filter_search = "";
		if( $v_division_filter != '' ) {
			$v_division_filter_implode = "'" . implode ( "', '", \U::safe_sql_string($v_division_filter)) . "'";
			$v_division_filter_search = " AND ( division IN(".$v_division_filter_implode.") ) ";
		}
		$v_status_filter = $p_cond['status_filter'];
		$v_status_filter_search = "";
		if( $v_status_filter != '' ) {
			$v_status_filter_implode = "'" . implode ( "', '", \U::safe_sql_string($v_status_filter)) . "'";
			$v_status_filter_search = " AND ( _rec_status IN(".$v_status_filter_implode.") ) ";
		}
		$v_limitation_data = "";
		if( $p_page_start != '' && $p_page_length != '' ) {
			$v_limitation_data = " LIMIT " . \U::safe_sql_string($p_page_start) . ", " . \U::safe_sql_string($p_page_length) . "";
		}
		$v_order_by = "";
		if( $p_order_by != '' && $p_sort_by != '' ) {
			$v_order_by = " ORDER BY " . \U::safe_sql_string($p_order_by) . " " . \U::safe_sql_string($p_sort_by) . " ";
 		}
		$v_query = "
				SELECT
					*
				FROM
					" . $this->get_db_table_prefix() . "locations 
				WHERE 
				 	_rec_status = \"SHOW\" 
				 	".$v_location_name_code_search." 
				 	".$v_agency_filter_search." 
				 	".$v_location_condition." 
				 	".$v_division_filter_search." 
				 	".$v_agency_condition."
				 	".$v_status_filter_search." 
				 	".$v_order_by."
				 	".$v_limitation_data."
				";
		return $this->co_db_root->execute_query($v_query);
	}
	/**
	 * Hard del user role
	 *
	 * @access public
	 * @return
	 */
	public function user_role_delete( $p_value ){
		$v_query = 	"DELETE FROM 
						" . $this->get_db_table_prefix() . "user_roles 
					WHERE 
						id = \"" . \U::safe_sql_string( $p_value['id'] ) . "\"
					";
		$v_result = $this->co_db_root->execute_query($v_query);
		if( $v_result ){
			return TRUE;
		} else {
			return FALSE;
		}
	}
	/**
	 * Get location by AGENCY ID
	 *
	 * @access public
	 * @return
	 */
	public function location_get_by_agency($p_agency_id) {
		if( isset($p_agency_id) ) {
			$v_query = "SELECT
							*
				 		FROM 
				 			" . $this->get_db_table_prefix() . "locations 
				 		WHERE
				 			agency_id = '".\U::safe_sql_string($p_agency_id)."'
				 ";
			$v_locations_data = $this->co_db_root->execute_query($v_query);	
			return $v_locations_data;
		}
	}
	/**
	 * Get location BY USER LOCATION ID
	 *
	 * @access public
	 * @return
	 */
	public function location_get_by_user_location() {
		$v_col_name = "id";
		$v_location_condition = \E::get('obj_curr_module')->get_location_condition($v_col_name);
		$v_col_name = "agency_id";
		$v_agency_condition = \E::get('obj_curr_module')->get_agency_condition($v_col_name);
		$v_query = "SELECT
						*
			 		FROM 
			 			" . $this->get_db_table_prefix() . "locations 
			 		WHERE
			 			1=1
			 			".$v_location_condition."
			 			".$v_agency_condition."
			 ";
		$v_locations_data = $this->co_db_root->execute_query($v_query);	
		return $v_locations_data;
	}
	/**
	 * Get location BY USER LOCATION ID
	 *
	 * @access public
	 * @return
	 */
	public function location_get_location_admin_users() {
		$v_result = "";
		$v_all_location_admins = "";
		$v_c_user_location_id = \E::get_session( "c_user_location_id");
		$v_col_name = "agency";
		$v_agency_condition = \E::get('obj_curr_module')->get_agency_condition($v_col_name);
        if( isset($v_c_user_location_id) && ($v_c_user_location_id != "") && ($v_c_user_location_id != 0) ) {
        	$v_query = "SELECT
						location_administrators
			 		FROM 
			 			" . $this->get_db_table_prefix() . "locations 
			 		WHERE
			 			id = '".\U::safe_sql_string($v_c_user_location_id)."'
			";
			$v_locations_data = $this->co_db_root->execute_query($v_query);	
			if( isset($v_locations_data[0]['location_administrators']) && $v_locations_data[0]['location_administrators'] != "" ) {
				$location_admins_exploded = explode(",", $v_locations_data[0]['location_administrators']);
				$v_result = "'" . implode ( "', '", \U::safe_sql_string($location_admins_exploded) ) . "'";
				if( $v_result != "" ) {
					$v_query = "SELECT
								usr_id,usr_short_name,usr_full_name
					 		FROM 
					 			" . $this->get_db_table_prefix() . "user
					 		WHERE
					 			_rec_status = \"SHOW\"
					 		AND
					 			usr_id IN(".$v_result.")
					 			".$v_agency_condition."
					";
					$v_all_location_admins = $this->co_db_root->execute_query($v_query);	
					if( isset($v_all_location_admins) && ( $v_all_location_admins != '' ) && ( count($v_all_location_admins) > 0 ) ) {
						return $v_all_location_admins;
					} else {
						$v_all_location_admins = "No location admin user Found!";
					}
				}
			}
        }
        return $v_all_location_admins;
	}
}
?>