<?php
namespace moonlight\eticket;
class eticket_user {
	private $co_db;
	public function __construct( $p_co_db ){
		$this->co_db = $p_co_db;
	}
	public function __destruct(){
		unset($this->co_db);
	}
	/*
	 * Function to get user acl
	 */
	public function user_acl_get( $p_id ){
		return $this->co_db->user_acl_get( $p_id );
	}
	// extra function for multiple access right
	public function user_acl_form_get( $p_id, $p_value = null ){
		return $this->co_db->user_acl_form_get( $p_id, $p_value );
	}
	/*
	 * Function to retrieve the list of user acl group
	 */
	public function user_acl_list( $p_order=null, $p_start = null, $p_num_of_rec = null, $p_value = null ){
		return $this->co_db->user_acl_list( $p_order, $p_start, $p_num_of_rec, $p_value );
	}
	/*
	 * Function to retrieve user specific agency data
	 */
	public function user_get_aganecy_data( $p_agency_id=null){
		return $this->co_db->user_get_aganecy_data( $p_agency_id );
	}
	/*
	 * Function to retrieve user data based on id
	 */
	public function user_get_data( $p_user_id=null){
		return $this->co_db->user_get_data( $p_user_id );
	}
	/*
	* Function to count the total of user acl group
	*/
	public function user_acl_list_total( $p_value = null ){
		return $this->co_db->user_acl_list_total( $p_value );
	}
	/*
	 * Function to check user group duplication
	 */
	public function user_group_check_duplicate($p_field_name=NULL, $p_field_value=NULL, $p_user_id=NULL){
		return $this->co_db->user_group_check_duplicate($p_field_name, $p_field_value,$p_user_id);
	}
	/*
	 * Function to check user field duplication
	 */
	public function user_check_duplicate_field($p_field_name=NULL, $p_field_value=NULL, $p_table_name=NULL){
		return $this->co_db->user_check_duplicate_field($p_field_name, $p_field_value,$p_table_name);
	}
	/*
	 * Function to check user field duplication on edit
	 */
	public function user_check_duplicate_field_edit($p_field_name=NULL, $p_field_value=NULL, $p_table_name=NULL, $p_table_primary_id=NULL, $p_primary_key_name=NULL){
		return $this->co_db->user_check_duplicate_field_edit($p_field_name, $p_field_value,$p_table_name,$p_table_primary_id,$p_primary_key_name);
	}
	/*
	 * Function to add user acl
	 */
	public function user_acl_add( $p_value ){
		$p_value['current_usr_id'] = \E::get_session('usr_id');
		$p_value['current_datetime'] = \E::get( 'obj_curr_module')->__now(); // Get the server date and time now
		$v_id = $this->co_db->user_acl_add( $p_value );
		return $v_id;
	}
	/*
	 * Function to update user acl details
	 */
	public function user_acl_edit( $p_value ){
		$p_value['current_usr_id'] = \E::get_session('usr_id');
		$p_value['current_datetime'] = \E::get( 'obj_curr_module')->__now(); // Get the server date and time now
		return $this->co_db->user_acl_edit( $p_value );
	}
	public function user_acl_del( $p_value, $p_del_method ){
		if($p_del_method=="0"){
			$p_value['current_usr_id'] = \E::get_session('usr_id');
			$p_value['current_datetime'] = \E::get( 'obj_curr_module')->__now(); // Get the server date and time now
			$v_result = $this->co_db->user_acl_soft_del( $p_value );
		}else{
			$v_result = $this->co_db->user_acl_hard_del( $p_value );
		}
		return $v_result;
	}
	/*
	 * Function to retrieve user listing with filters
	 */
	public function user_list_with_no_post($p_cond=NULL, $p_sort_by=NULL, $p_order_by=NULL, $p_page_start=NULL, $p_page_length=NULL){
		return $this->co_db->user_list_with_no_post($p_cond, $p_sort_by, $p_order_by, $p_page_start, $p_page_length);
	}
	/*
	 * Function to retrieve user role data
	 */
	public function user_get_role_data($p_role_id){
		return $this->co_db->user_get_role_data($p_role_id);
	}
	/*
	 * Get Location and Agency Wise Data
	 */
	public function user_get_location_agency_wise($p_location_id=NULL){
		return $this->co_db->user_get_location_agency_wise($p_location_id);
	}
	/*
	 * Get Location and Agency Wise Data
	 */
	public function user_authorize_user($p_user_name,$p_user_password=NULL){
		return $this->co_db->user_authorize_user($p_user_name,$p_user_password);
	}
	/*
	 * Function to check user field duplication
	 */
	public function user_check_duplicate_field_user_role($p_role_name, $p_agency_id){
		return $this->co_db->user_check_duplicate_field_user_role($p_role_name, $p_agency_id);
	}
	/*
	 * Function to check user field duplication
	 */
	public function user_check_duplicate_field_user_role_edit($p_role_name, $p_agency_id, $p_role_id){
		return $this->co_db->user_check_duplicate_field_user_role_edit($p_role_name, $p_agency_id, $p_role_id);
	}
}
?>